<?php

/* 
 playtrulyrandom.com Webservice Component
 (c) A. Schiffler, 2008-2010, GPL
 
 usage.php - Track usage statistics of user by RNG mode and duration.
*/

include ("config.inc.php");

/* make DB connection */
$mysqli = new mysqli($sconfig['server'], $config['user'], $config['password'], $config['database']);

/* check connection */
if (mysqli_connect_errno()) {
    printf("Connect failed: %s\n", mysqli_connect_error());
    exit();
} 

/* get source name */
$sourcename = $_REQUEST["source"];
if (!$sourcename)
{
   printf("-1");
   exit(0);
}

/* get user name */
$username = $_REQUEST["user"];
if (!$username)
{
   printf("-2");
   exit(0);
}

/* Find sourceid */
$sourceid=0;
$sourcename = $mysqli->real_escape_string ($sourcename);
$query = sprintf("SELECT sourceid FROM source WHERE name='%s'", $sourcename);
if ($result = $mysqli->query($query)) {
   if ($row = $result->fetch_assoc()) {
      $sourceid = $row["sourceid"];
   }
   $result->close();
}
 
if (!$sourceid)
{
   printf("-3");
   exit(0);
}

/* Find userid  */
$userid = 0;
$username = $mysqli->real_escape_string ($username);
$query = sprintf("SELECT userid FROM user WHERE name='%s'", $username);
if ($result = $mysqli->query($query)) {
   if ($row = $result->fetch_assoc()) {
      $userid = $row["userid"];
   }
   $result->close();
}

/* Do we have a user */ 
if (!$userid)
{
      printf("-4");
      exit(0);
}

/* Get mode, assume pseudo */ 
$hrngmode=$_REQUEST["hrngmode"] + 0; 

/* Get duration length */ 
$duration=$_REQUEST["duration"] + 0; 
if ($duration<1)
{
   printf("-5");
   exit(0);
}

/* Store usage */
$query = sprintf("INSERT INTO usagestats (sourceid,userid,hrngmode,durationsec,timestamp) VALUES (%d,%d,%d,%d,CURRENT_TIMESTAMP);",$sourceid,$userid,$hrngmode,$duration);
if ($result = $mysqli->query($query))
{
   $result->close();  
} 
else 
{
   printf("-6");
   exit(0);
}
 
/* close connection */
$mysqli->close();

?>